Description: Fix FTBFS with Limux 5.0
Author: Seth Forshee <seth.forshee@canonical.com>
Bug-Ubuntu: https://bugs.launchpad.net/bugs/1818833

Index: sl-modem-2.9.11~20110321/drivers/amrmo_init.c
===================================================================
--- sl-modem-2.9.11~20110321.orig/drivers/amrmo_init.c
+++ sl-modem-2.9.11~20110321/drivers/amrmo_init.c
@@ -331,22 +331,37 @@ static struct class_simple *amrmo_class;
 
 unsigned amrmo_debug_level = 0;
 
+static void get_time(long *sec, long *usec)
+{
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(5,0,0))
+    struct timeval t;
+    do_gettimeofday (&t);
+    *sec = (long)t.tv_sec;
+    *usec = (long)t.tv_usec;
+#else
+    struct timespec64 ts;
+    ktime_get_coarse_ts64(&ts);
+    *sec = (long)ts.tv_sec;
+    *usec = (long)(ts.tv_nsec / NSEC_PER_USEC);
+#endif
+}
+
 static int amrmo_vprintf(const char *fmt, va_list args)
 {
 	static char temp[4096];
-	struct timeval tv;
+	long sec, usec;
 	unsigned long len;
 	char *p;
 	int ret;
 	if (!fmt || !(len = strlen(fmt)))
 		return -1;
-	do_gettimeofday(&tv);
+	get_time(&sec, &usec);
 	while (*fmt == '\n' || *fmt == '\r' || *fmt == '\t' || *fmt == ' ')
 		fmt++;
 	p = temp;
 	len = sprintf(p, "<%c%03ld.%06ld> ",
 		      in_interrupt() ? 'i' : 'p',
-		      (tv.tv_sec % 1000), tv.tv_usec);
+		      (sec % 1000), usec);
 	p += len;
 	ret = vsprintf(p, fmt, args);
 	len += ret;
@@ -390,7 +405,11 @@ static ssize_t amrmo_read(struct file *f
 	struct amrmo_struct *amrmo = (struct amrmo_struct *)file->private_data;
 	int ret;
 	//AMRMO_DBG("amrmo_read...\n");
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(5,0,0))
 	if(!access_ok(VERIFY_READ, buffer, count))
+#else
+	if(!access_ok(buffer, count))
+#endif
 		return -EFAULT;
 	if (count > sizeof(amrmo->ibuf))
 		count = sizeof(amrmo->ibuf);
@@ -405,7 +424,11 @@ static ssize_t amrmo_write(struct file *
 	struct amrmo_struct *amrmo = (struct amrmo_struct *)file->private_data;
 	int ret;
 	//AMRMO_DBG("amrmo_write...\n");
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(5,0,0))
 	if(!access_ok(VERIFY_WRITE, buffer, count))
+#else
+	if(!access_ok(buffer, count))
+#endif
 		return -EFAULT;
 	if (count > sizeof(amrmo->obuf))
 		count = sizeof(amrmo->obuf);
Index: sl-modem-2.9.11~20110321/drivers/sysdep_amr.c
===================================================================
--- sl-modem-2.9.11~20110321.orig/drivers/sysdep_amr.c
+++ sl-modem-2.9.11~20110321/drivers/sysdep_amr.c
@@ -110,9 +110,15 @@ asmlinkage int sysdep_sprintf(char *buf,
 /* getting times */
 asmlinkage unsigned long sysdep_get_utime(void)
 {
+#if (LINUX_VERSION_CODE < KERNEL_VERSION(5,0,0))
     struct timeval t;
     do_gettimeofday (&t);
     return t.tv_sec * 1000000 + t.tv_usec ;
+#else
+    struct timespec64 ts;
+    ktime_get_coarse_ts64(&ts);
+    return ts.tv_sec * 1000000 + ts.tv_nsec / NSEC_PER_USEC;
+#endif
 }
 
 /* cli/sti handling */
